SystemOrganization addCategory: #'TP2-TADP'!
SystemOrganization addCategory: #'TP2-TADP-Fixture'!
SystemOrganization addCategory: #'TP2-TADP-Tests'!

Object subclass: #AttributeWithUsages
	instanceVariableNames: 'attribute usages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP'!

!AttributeWithUsages class methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/2/2013 00:06'!
forAttribute: anAttributeName usages: someUsages
	^self new attribute: anAttributeName ; usages: someUsages ; yourself! !

!AttributeWithUsages methodsFor: 'accessing' stamp: 'FedericoAloi 5/2/2013 00:08'!
attribute
	^ attribute! !

!AttributeWithUsages methodsFor: 'accessing' stamp: 'FedericoAloi 5/2/2013 00:08'!
attribute: anObject
	attribute := anObject! !

!AttributeWithUsages methodsFor: 'accessing' stamp: 'FedericoAloi 5/2/2013 00:07'!
usages
	^ usages! !

!AttributeWithUsages methodsFor: 'accessing' stamp: 'FedericoAloi 5/2/2013 00:07'!
usages: anObject
	usages := anObject! !

Object subclass: #InteractionGroup
	instanceVariableNames: 'methods attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP'!

!InteractionGroup methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/2/2013 01:41'!
addAttribute: anAttribute
	self attributes add: anAttribute ! !

!InteractionGroup methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/2/2013 01:40'!
addMethods: someMethods
	self methods addAll: someMethods ! !

!InteractionGroup methodsFor: 'accessing' stamp: 'FedericoAloi 5/2/2013 01:42'!
attributes
	^ attributes! !

!InteractionGroup methodsFor: 'accessing' stamp: 'FedericoAloi 5/2/2013 01:42'!
attributes: anObject
	attributes := anObject! !

!InteractionGroup methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/2/2013 01:39'!
initialize
	self methods: Set new.
	self attributes: Set new.! !

!InteractionGroup methodsFor: 'accessing' stamp: 'FedericoAloi 5/2/2013 01:42'!
methods
	^ methods! !

!InteractionGroup methodsFor: 'accessing' stamp: 'FedericoAloi 5/2/2013 01:42'!
methods: anObject
	methods := anObject! !

Object subclass: #MetaUtil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP-Tests'!

!MetaUtil class methodsFor: 'as yet unclassified' stamp: 'Demian 9/8/2012 00:29'!
recreateCategory: categoryName
	(SystemOrganization listAtCategoryNamed: categoryName) do: [ :typeName | Smalltalk removeClassNamed: typeName ].
	SystemOrganization removeCategory: categoryName.
	FileStream fileIn: categoryName , '.st'.
	SystemOrganization sortCategories! !

Object subclass: #TheBlob
	instanceVariableNames: 'interactionGroups'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP'!

!TheBlob methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/2/2013 01:43'!
canBePerformedFor: someAttributesWithUsages
	self createInteractionGroupsFor: someAttributesWithUsages.
	^self interactionGroups size > 1! !

!TheBlob methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/2/2013 01:38'!
createInteractionGroup
	| newInteractionGroup |
	newInteractionGroup := InteractionGroup new.
	self interactionGroups add: newInteractionGroup.
	^newInteractionGroup! !

!TheBlob methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/2/2013 01:46'!
createInteractionGroupsFor: someAttributesWithUsages
	someAttributesWithUsages do: [ :anAttributeWithUsages | 
			(self findOrCreateInteractionGroupFor: anAttributeWithUsages)
				addAttribute: anAttributeWithUsages attribute;
				addMethods: anAttributeWithUsages usages 
	]! !

!TheBlob methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/2/2013 02:00'!
findOrCreateInteractionGroupFor: anAttributeWithUsages
	^ self interactionGroups 
		detect: [ :anInteractionGroup | anInteractionGroup methods includesAny: anAttributeWithUsages usages ]
		ifNone: [self createInteractionGroup]! !

!TheBlob methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/2/2013 01:36'!
initialize
	self interactionGroups: Bag new! !

!TheBlob methodsFor: 'accessing' stamp: 'FedericoAloi 5/2/2013 01:37'!
interactionGroups
	^ interactionGroups! !

!TheBlob methodsFor: 'accessing' stamp: 'FedericoAloi 5/2/2013 01:37'!
interactionGroups: anObject
	interactionGroups := anObject! !

Object subclass: #TheInterceptor
	instanceVariableNames: 'afterCode beforeCode theClasses theMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP'!

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 19:18'!
addACategory: unaCategoriaString
	theClasses addAll: (Object subclasses select: [ :aClass | aClass category == (unaCategoriaString asSymbol)]).

! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 18:28'!
addClasses: anString
	| classesNames |
	classesNames := anString subStrings: ' '.
	theClasses addAll: (classesNames collect: [ :name | Compiler evaluate: name]).! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 20:38'!
agregarCodigo
	| codes |
	codes := self getTheMethods collect: [ :method | self getBeforeCode , method sourceCode, self getAfterCode ].
	^codes! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 17:45'!
getAfterCode
	
	^ afterCode! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 17:47'!
getBeforeCode
	
	^ beforeCode! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 18:24'!
getTheClasses
	
	^ theClasses! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 20:38'!
getTheMethods
	
	^ theMethods! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 19:27'!
initialize 
	theClasses := Bag new.
	theMethods := Bag new.! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 20:35'!
methodsBeginWith: anString
	| allMethods |
	allMethods := (theClasses collect: [ :aClass | aClass methods]).
	^ allMethods gather: [ :arrayMethods | arrayMethods select:  [:aMethod | (aMethod selector beginsWith: anString asSymbol)]].! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 20:37'!
selectAccessors
	theMethods addAll: (self methodsBeginWith: 'set').
	theMethods addAll: (self methodsBeginWith: 'get').! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 20:36'!
selectMethodsBeginWith: anString
	theMethods addAll: (self methodsBeginWith: anString)! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 17:46'!
setAfterCode: anObject
	
	afterCode := anObject! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 17:47'!
setBeforeCode: anObject
	
	beforeCode := anObject! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 18:23'!
setTheClasses: anObject
	
	theClasses := anObject! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 20:38'!
setTheMethods: anObject
	
	theMethods := anObject! !

TestCase subclass: #RefactorsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP-Tests'!

!RefactorsTest methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 4/30/2013 01:31'!
setUp
	MetaUtil recreateCategory: 'TP2-TADP-Fixture'! !

TestCase subclass: #TheBlobTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP-Tests'!

!TheBlobTest commentStamp: '<historical>' prior: 0!
A TheBlobTest is a test class for testing the behavior of TheBlob!

!TheBlobTest methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/2/2013 00:04'!
test1
	| attributesWithUsages |
	
	attributesWithUsages := { 
		AttributeWithUsages forAttribute: 'nombre' usages: { #nombreCompleto }.
		AttributeWithUsages forAttribute: 'edad' usages: { #esMayorDeEdad }.		
	}.
	
	self assert: (TheBlob new canBePerformedFor: attributesWithUsages)! !

!TheBlobTest methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/2/2013 00:09'!
test2
	| attributesWithUsages |
	
	attributesWithUsages := { 
		AttributeWithUsages forAttribute: 'nombre' usages: { #nombreCompleto }.
	}.
	
	self deny: (TheBlob new canBePerformedFor: attributesWithUsages)! !

!TheBlobTest methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/2/2013 00:55'!
test4
	| attributesWithUsages |
	
	attributesWithUsages := { 
		AttributeWithUsages forAttribute: 'nombre' usages: { #nombreCompleto. #presentate }.
		AttributeWithUsages forAttribute: 'apellido' usages: { #nombreCompleto. #presentate }.		
		AttributeWithUsages forAttribute: 'edad' usages: { #esMayorDeEdad. #puedeVotar }.
		AttributeWithUsages forAttribute: 'nacionalidad' usages: { #esMayorDeEdad. #puedeVotar }.		
	}.
	
	self assert: (TheBlob new canBePerformedFor: attributesWithUsages)! !

!TheBlobTest methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/2/2013 00:16'!
test6
	| attributesWithUsages |
	
	attributesWithUsages := { 
		AttributeWithUsages forAttribute: 'nombre' usages: { #nombreCompleto. #presentate }.
		AttributeWithUsages forAttribute: 'apellido' usages: { #nombreCompleto. #presentate }.		
	}.
	
	self deny: (TheBlob new canBePerformedFor: attributesWithUsages)! !

!TheBlobTest methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/2/2013 00:31'!
test7
	| attributesWithUsages |
	
	attributesWithUsages := { 
		AttributeWithUsages forAttribute: 'nombre' usages: { #nombreCompleto. #presentate }.
		AttributeWithUsages forAttribute: 'apellido' usages: { #nombreCompleto }.		
	}.
	
	self deny: (TheBlob new canBePerformedFor: attributesWithUsages)! !
